[bits 32]

; Setup own opcode
db 1          ; Move_MemImm
dd 0x02004000 ; Special.UserOpcodeVectors[0] (0x80)
dd substract  ; Addr of handler

; Test substract
db 1          ; Move_MemImm
dd 0x01000000 ; (RAM 000000)
dd 1234       ; 1234

db 1          ; Move_MemImm
dd 0x01000004 ; (RAM 000004)
dd 1000       ; 1000

; Go go substract (1234 - 234 should be 1000)
db 0x80       ; User_Substract
dd 0x01000000 ; (RAM 000000)
dd 234        ; 234

; Test
db 0x12       ; GotoEqual_ImmMemMem
dd is_equal   ; Addr of jump
dd 0x01000000 ; Result of substract
dd 0x01000004 ; Good stuff

; Bad ? Exception 0xFF
db 0xFF

; Good ? Exception 0xFE
is_equal:
db 0xFE


; Own Opcode
; 0x80 Substract DWORD_MEM DWORD_IMM (9 bytes total)
; Pseudo code:
; VAR_A = Return Addr + 1
; VAR_B = *VAR_A
; VAR_A += 4;
; VAR_C = *VAR_A
; VAR_A += 4;
; VAR_C = -VAR_C (this is equal to VAR_C = ~VAR_C + 1)
; VAR_D = *VAR_B
; VAR_D += VAR_C
; *VAR_B = VAR_D
; Goto *VAR_A
substract:
db 2          ; Move_MemMem
dd 0x01F00000 ; VAR_A
dd 0x02000004 ; Special.IntReturnAddr

; Unblock int
db 0x15       ; ReleaseInt

db 3          ; Add_MemImm
dd 0x01F00000 ; VAR_A
dd 1          ; 1

db 0x10       ; MovePtrFrom_MemMem
dd 0x01F00004 ; VAR_B
dd 0x01F00000 ; *VAR_A

db 3          ; Add_MemImm
dd 0x01F00000 ; VAR_A
dd 4          ; 4

db 0x10       ; MovePtrFrom_MemMem
dd 0x01F00008 ; VAR_C
dd 0x01F00000 ; *VAR_A

db 3          ; Add_MemImm
dd 0x01F00000 ; VAR_A
dd 4          ; 4

db 0x0f       ; Neg_Mem
dd 0x01F00008 ; VAR_C

db 3          ; Add_MemImm
dd 0x01F00008 ; VAR_C
dd 1          ; 4

db 0x10       ; MovePtrFrom_MemMem
dd 0x01F0000C ; VAR_D
dd 0x01F00004 ; *VAR_B

db 4          ; Add_MemMem
dd 0x01F0000C ; VAR_D
dd 0x01F00008 ; VAR_C

db 0x11       ; MovePtrTo_MemMem
dd 0x01F00004 ; *VAR_B
dd 0x01F0000C ; VAR_D

db 0x0D       ; Goto_Mem
dd 0x01F00000 ; VAR_A


